#!/bin/sh

## M$ sucks
unset LIB

## run the build with ntsec on if possible...
pkg=perl
ver=5.8.7
major=5.8
release=-5
dir=`pwd`
shortver=`echo ${ver}${release} | sed 's/-.*//'`
buildperl=buildperl

## checkout builddir
rm -rf ${dir}/${buildperl}
mkdir -p -m 777 ${dir}/${buildperl}

## unpack
rm -rf ${pkg}-${ver}
tar jxf ${pkg}-${ver}.tar.bz2
tar xjvf ${pkg}-${ver}-ext-Win32CORE.tar.bz2
mkdir -p /usr/share/doc/${pkg}-${ver}
/bin/install -c -m 644 ${pkg}-${ver}/Artistic ${pkg}-${ver}/Copying ${pkg}-${ver}/README /usr/share/doc/${pkg}-${ver}

## patch to strip the binaries & dll's
(cd ${pkg}-${ver} ; patch -p1<../hints.cygwin.sh.patch)
## dll naming major version patch
(cd ${pkg}-${ver} ; patch -p1<../major.version.cygwin.sh.patch)
## Kid.ppm patch
(cd ${pkg}-${ver} ; patch -p1<../Kid.pm.patch)
## Win32CORE patch
(cd ${pkg}-${ver} ; patch -p1<../p587w32core.patch)
## Try to fix TH problem
(cd ${pkg}-${ver} ; patch -p1<../Straps.pm.patch)
## Patch to issue reported here:
## http://www.gentoo.org/security/en/glsa/glsa-200512-01.xml
## http://bugs.gentoo.org/show_bug.cgi?id=114113
## http://www.dyadsecurity.com/perl-0002.html
(cd ${pkg}-${ver} ; patch -p1<../sprintf-5.8.7.patch)

## configure perl
cd ${dir}/${buildperl}

cp ${dir}/Policy.sh ${dir}/${buildperl}

sh ${dir}/${pkg}-${ver}/Configure -de	\
		-Dmksymlinks	\
		-Duse64bitint	\
		-Dusethreads	\
		-Uusemymalloc   \
		-Doptimize='-O3'	\
		-Dman3ext='3pm'	\
		-Dusesitecustomize \
		2>&1 | tee ${dir}/log.configure

# Implied by usethreads
#		-Dusemultiplicity	\
#		-Uusemymalloc	\

## build perl
make 2>&1 | tee ${dir}/log.make

cp /usr/bin/cygcrypt-0.dll .

## make the tests
export PERLIO=perlio
make test 2>&1 | tee ${dir}/log.test
(cd t;./perl harness) 2>&1 | tee ${dir}/log.harness

rm -f cygcrypt-0.dll

## install
make install-strip 2>&1 | tee ${dir}/log.install

cd ${dir}
for i in \
         Compress-Zlib-1.41	\
         Compress-Bzip2-2.09 \
         IO-Zlib-1.04	\
         IO-String-1.07	\
         Text-Diff-0.35 \
         Archive-Tar-1.26	\
         MD5-2.03	\
         Term-ReadLine-Perl-1.0203 \
         Net-Telnet-3.03	\
         TermReadKey-2.30	\
         XML-Parser-2.34;	\
do (tar xzf ${i}.tar.gz &&	\
    (cd ${i} &&	\
    perl Makefile.PL &&	\
    make &&	\
    make install_vendor UNINST=1));	\
done

cd ${dir}
for i in \
         Proc-ProcessTable-0.40; \
do (tar xzf ${i}.tar.gz &&	\
    (cd ${i} &&	\
    patch -p0 < ../Proc-ProcessTable-0.40.patch && \
    perl Makefile.PL &&	\
    make &&	\
    make install_vendor UNINST=1));	\
done
